package org.openxma.dsl.common.syntaxcoloring;

import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.nodemodel.util.NodeModelUtils;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.ui.editor.syntaxcoloring.IHighlightedPositionAcceptor;
import org.eclipse.xtext.ui.editor.syntaxcoloring.ISemanticHighlightingCalculator;

abstract public class OpenXMASemanticHighlightingCalculator implements ISemanticHighlightingCalculator {

    abstract public void provideHighlightingFor(XtextResource resource, IHighlightedPositionAcceptor acceptor);

    protected INode getFirstFeatureNode(EObject semanticObject, EStructuralFeature structuralFeature) {
        List<INode> nodesForFeature = NodeModelUtils.findNodesForFeature(semanticObject, structuralFeature);
        return nodesForFeature.isEmpty() ? null : nodesForFeature.get(0);
    }

    protected void highlightNode(INode node, String id, IHighlightedPositionAcceptor acceptor) {
        if (node == null)
            return;
        acceptor.addPosition(node.getOffset(), node.getLength(), id);
    }

}
